AppTitle "MouseBlocker"

Global funcvar_prison_hide
Global funcvar_prison_time

Global window=CenterWindow("MouseBlocker",320,240,0,33)

Global img_mouse=LoadImage(".\data\pointer.bmp")
Global img_prison=LoadAnimImage(".\data\prison.bmp",30,30,0,2)

HotKeyEvent 1,0,$10

Global label=CreateLabel("Press 'Esc' to lock/free",50,18,120,20,window)

CreateLabel "Log:",10,50,50,20,window
Global Log_=CreateTextArea(10,70,300,160,window)
SetGadgetFont Log_,LoadFont("Fixedsys",20)

Global clr_Button=CreateButton("Clear",255,42,50,20,window)
Global info_Button=CreateButton("Info",255,15,50,20,window)

Global canvas=CreateCanvas(10,10,30,30,window)
SetBuffer CanvasBuffer(Canvas)

lock=False

Repeat
	Select WaitEvent(0)
		Case $803
			End
		Case $401
			Select EventSource()
				Case clr_button
					SetGadgetText log_,""
					ActivateGadget window
				Case info_button
					Notify "MouseBlocker"+Chr(10)+"Developed by Chingun A."+Chr(10)+Chr(10)+"Press 'Esc' to switch between locked and unlocked"+Chr(10)+"Press 'Clear' button to clear the Log."+Chr(10)+"The log won't note mouse actions if mouse is unlocked."+Chr(10)+"Unfortunaly it can't block always, but it's enough to "+Chr(10)+"block little children."
					ActivateGadget window
			End Select
		Case $10
			lock=Not lock
			If Not lock Then
				;funcvar_prison_time=MilliSecs()
				AddTextAreaText Log_,"<"+CurrentTime()+";Program> unlock"+Chr(10)
			Else
				AddTextAreaText Log_,"<"+CurrentTime()+";Program> lock"+Chr(10)
			EndIf
			
	End Select
	If lock Then Note()
	Prison(lock)
Forever

Function Note()
	xspeed=MouseXSpeed()
	yspeed=MouseYSpeed()
	zspeed=MouseZSpeed()
	button1hit=MouseHit(1)
	button2hit=MouseHit(2)
	button3hit=MouseHit(3)
	If xspeed<>0  Then
		If xspeed<0 Then
			AddTextAreaText Log_,"<"+CurrentTime()+";Mouse> (<-)left"+Chr(10)
		ElseIf xspeed>0 Then
			AddTextAreaText Log_,"<"+CurrentTime()+";Mouse> (->)right"+Chr(10)
		EndIf
	EndIf
	If yspeed<>0  Then
		If yspeed<0 Then
			AddTextAreaText Log_,"<"+CurrentTime()+";Mouse> (/\)up"+Chr(10)
		ElseIf yspeed>0 Then
			AddTextAreaText Log_,"<"+CurrentTime()+";Mouse> (\/)down"+Chr(10)
		EndIf
	EndIf
	If zspeed<>0  Then
		If zspeed<0 Then
			AddTextAreaText Log_,"<"+CurrentTime()+";Mouse wheel> (/\)up"+Chr(10)
		ElseIf zspeed>0 Then
			AddTextAreaText Log_,"<"+CurrentTime()+";Mouse wheel> (\/)down"+Chr(10)
		EndIf
	EndIf
	If button1hit Then
		AddTextAreaText Log_,"<"+CurrentTime()+";Mouse button> left"+Chr(10)
	EndIf
	If button2hit Then
		AddTextAreaText Log_,"<"+CurrentTime()+";Mouse button> right"+Chr(10)
	EndIf
	If button3hit Then
		AddTextAreaText Log_,"<"+CurrentTime()+";Mouse button> middle"+Chr(10)
	EndIf
End Function

Function Prison(lock)
	If lock Then
		funcvar_prison_hide=1
		MoveMouse 10,6,canvas
		HidePointer canvas
	Else
		funcvar_prison_hide=0
		ShowPointer canvas
	EndIf
	
	Cls
	If funcvar_prison_hide Then DrawImage img_mouse,MouseX(canvas),MouseY(canvas)
	DrawImage img_prison,0,0,Not lock
	FlipCanvas canvas
End Function

Function CenterWindow (title$, width, height, group = 0, style = 15)
	Return CreateWindow (title$, (ClientWidth (Desktop ()) / 2) - (width / 2), (ClientHeight (Desktop ()) / 2) - (height / 2), width, height, group, style)
End Function



















